<?php

namespace Drupal\view_tempstore_clear\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;
use Drupal\Console\Core\Command\Command;

/**
 * Class CleanUpViewTempstoreConsoleCommand.
 *
 * Drupal\Console\Annotations\DrupalCommand (
 *     extension="view_tempstore_clear",
 *     extensionType="module"
 * )
 */
class CleanUpViewTempstoreConsoleCommand extends Command {

  /**
   * {@inheritdoc}
   */
  protected function configure() {
    $this
      ->setName('views:tempstore:clean')
      ->addArgument(
        'name',
        InputOption::VALUE_OPTIONAL,
      )
      ->setAliases(['view-clean']);
  }

  /**
   * {@inheritdoc}
   */
  protected function interact(InputInterface $input, OutputInterface $output) {
    $name = $this->getIo()->ask(
        $this->trans('Enter view machine name to clean up tempstore or leave empty for clear all'),
        'all',
      );
    $input->setArgument('name', $name);
  }

  /**
   * {@inheritdoc}
   */
  protected function execute(InputInterface $input, OutputInterface $output) {
    $name = $input->getArgument('name');

    /** @var \Drupal\view_tempstore_clear\CleanUpViewTempstore $clean_up_view_tempstore */
    $clean_up_view_tempstore = \Drupal::service('view.tempstore.cleanup');
    $clean_up_view_tempstore->viewTempstoreCleanup($name);
    $messenger = $clean_up_view_tempstore->messenger->all();

    foreach ($messenger as $key => $value) {
      $key = $key === 'status' ? 'success' : $key;
      $this->getIo()->$key($value);
    }
  }

}
