<?php

namespace Drupal\view_tempstore_clear\Commands;

use Drush\Commands\DrushCommands;

/**
 * A Drush command to clean up view tempstore.
 */
class CleanUpViewTempstoreCommand extends DrushCommands {

  /**
   * Clean up view tempstore by key name or all views.
   *
   * @param string $name
   *   View machine name argument.
   *
   * @command views:tempstore:clean
   * @aliases view-clean
   * @usage views:tempstore:clean view_name
   *
   * @throws \Drupal\Core\TempStore\TempStoreException
   */
  public function CleanUp(string $name = 'all') {
    // Asks for set new or use default argument.
    if ($name === 'all') {
      $name = $this->io()->ask('Enter view machine name to clean up tempstore or leave empty for clear all', $name);
    }

    /** @var \Drupal\view_tempstore_clear\CleanUpViewTempstore $clean_up_view_tempstore */
    $clean_up_view_tempstore = \Drupal::service('view.tempstore.cleanup');
    $clean_up_view_tempstore->viewTempstoreCleanup($name);
  }

}
