<?php

namespace Drupal\view_tempstore_clear\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

class CleanUpViewTempstoreForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'view_tempstore_cleanup_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form['text_field'] = [
      '#type' => 'textfield',
      '#title' => $this->t('View key name'),
      '#description' => $this->t("View Machine name like 'content' or 'newest_users'."),
    ];
    $form['actions']['#type'] = 'actions';
    $form['actions']['submit_one'] = [
      '#type' => 'submit',
      '#value' => $this->t('Cleanup view by machine name'),
      '#button_type' => 'primary',
      '#name' => 'submit_one',
    ];
    $form['actions']['submit_multiple'] = [
      '#type' => 'submit',
      '#value' => $this->t('Cleanup all views'),
      '#button_type' => 'secondary',
      '#name' => 'submit_multiple',
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    /** @var \Drupal\view_tempstore_clear\CleanUpViewTempstore $clean_up_view_tempstore */
    $clean_up_view_tempstore = \Drupal::service('view.tempstore.cleanup');
    $button_clicked = $form_state->getTriggeringElement()['#name'];
    $name = '';

    if ($button_clicked === 'submit_one') {
      $name = $form_state->getValue('text_field');
    }
    elseif ($button_clicked === 'submit_multiple') {
      $name = 'all';
    }

    $clean_up_view_tempstore->viewTempstoreCleanup($name);
  }

}
